/*++

	This program is free software; you can redistribute it
	and/or modify it under the terms of the Shared Code
	License (SCL) as published by www.IntellectualHeaven.com;
	either version 1.0, or (at your option) any later version.
	You should have received a copy of the SCL 1.0 license,
	look for file license.txt, along with this software; if not,
	then please write to x_pankaj_x@intellectualheaven.com
	for an electronic copy of the same.

Module Name:

    YArchDecode.cpp

Module Description:

	Main file for YahDecode. It contains WinMain and other useful
	stuff.

Author:

    Pankaj Garg		2004-09-17
    
Revision History:

--*/

// System Include Files!!!
#include <windows.h>
#include <commctrl.h>
#include <stdlib.h>
#include <tchar.h>

// Local Include Files!!!
#include "YArchDecode.h"
#include "resource.h"
#include "YArchDecodeView.h"


//
// Global view object
//
CYArchDecode *g_pViewObj = NULL;



/*++

Routine Name:
	
	WndProc

Routine Description:
	
	Our Windows message handling routine. Routes control to
	our view class's message handling code.

Returns:

	If a message is handled the return value is zero. Otherwise
	its non-zero.
	

--*/
LRESULT CALLBACK 
WndProc(    HWND hwnd,
            UINT nMsg,
            WPARAM wParam,
            LPARAM lParam)
{
    return g_pViewObj->WndProc( hwnd,
                                nMsg,
                                wParam,
                                lParam);
}



/*++

Routine Name:
	
	WinMain

Routine Description:
	
	Entry point for the application

Returns:

	<XXX>
	

--*/
int WINAPI
WinMain(    HINSTANCE hInstance,
            HINSTANCE /* hPrevInstance */,
            PSTR  /* szCmdLine */,
            int /* iCmdShow */)
{
	int funcResult = 0;
    MSG msg;

    g_pViewObj = new CYArchDecode(hInstance);

    if (!g_pViewObj)
    {
        ::MessageBox(   NULL,
                        _T("Memory allocation failure.....\n"),
                        _T("Resource Error"),
                        MB_OK);
		funcResult = 1;
        goto funcExit;
    }
    
    g_pViewObj->InitInstance();


    //
    // Message loop
    //
    int status;
	while ((status = GetMessage(&msg, NULL, 0, 0)) != 0)
    {
		if (status == -1)
		{
			funcResult = -1;
			goto funcExit;
		}

		if (!TranslateAccelerator(g_pViewObj->GetMainWindow(), g_pViewObj->GetAccel(), &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
    }

funcExit:

	if (g_pViewObj)
	{
		delete g_pViewObj;
	}

    return funcResult;
}

